<template>
  <div class="app-container">
    <el-form :inline="true" label-width="68px" style="margin-bottom: 8px;">

      <el-form-item label="日期时间">
        <el-date-picker
          v-model="queryParams.beginCreateTime"
          type="date"
          placeholder="开始日期"
          class="baseInput"
          format="yyyy-MM-dd"
          value-format="yyyy-MM-dd"
          style="width: 200px;"
        >
        </el-date-picker>
        <span> - </span>
        <el-date-picker
          v-model="queryParams.endCreateTime"
          type="date"
          placeholder="结束日期"
          class="baseInput"
          format="yyyy-MM-dd"
          value-format="yyyy-MM-dd"
          style="width: 200px;"
        >
        </el-date-picker>
      </el-form-item>
      <el-form-item label="用户来源">
        <el-select
          v-model="queryParams.source"
          class="filter-item"
          placeholder="用户来源"
          style="width: 140px"
          filterable
          clearable
          remote
          reserve-keyword
        >
          <el-option
            v-for="item in sourceData"
            :key="item.source"
            :label="item.name"
            :value="item.source"
          ></el-option>
        </el-select>
      </el-form-item>
      <el-button class="filter-item" type="primary" icon="el-icon-search" @click="handleFind">筛选</el-button>
      <el-button class="filter-item" type="primary" icon="el-icon-s-flag" @click="exportData">导出</el-button>
    </el-form>

    <el-table :data="tableData" style="width:100%" :summary-method="getSummaries" show-summary class="show_table"  >
      <el-table-column label="日期" style="width:2%" align="center">
        <template slot-scope="scope">
          <span>{{scope.row.period}}</span>
        </template>
      </el-table-column>
      <el-table-column label="渠道" style="width:30%" :show-overflow-tooltip="true" align="center" prop="source">
        <template slot-scope="scope">
          <span>{{ scope.row.sourceName }}</span>
        </template>
      </el-table-column>
      <el-table-column label="新人领取用户总数（人）" style="width:30%" prop="loginFirstNum" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.loginFirstNum }}</span>
        </template>
      </el-table-column>
      <el-table-column label="绑定手机领取用户总数（人）" style="width:2%" prop="bindNum" :show-overflow-tooltip="true" align="center" >
        <template slot-scope="scope">
          <span>{{ scope.row.bindNum }}</span>
        </template>
      </el-table-column>
      <el-table-column label="会员领取用户总数（人）" style="width:2%" prop="vipNum" :show-overflow-tooltip="true" align="center" >
        <template slot-scope="scope">
          <span>{{ scope.row.vipNum }}</span>
        </template>
      </el-table-column>
      <el-table-column label="游戏币赠送用户总数（人）" style="width:2%" prop="giftCoinsNum" :show-overflow-tooltip="true" align="center" >
        <template slot-scope="scope">
          <span>{{ scope.row.giftCoinsNum }}</span>
        </template>
      </el-table-column>
      <el-table-column label="新人赠送总金额（元）" style="width:2%" prop="loginFirstAmount" :show-overflow-tooltip="true" align="center" >
        <template slot-scope="scope">
          <span>{{ scope.row.loginFirstAmount }}</span>
        </template>
      </el-table-column>
      <el-table-column label="绑定手机赠送总金额（元）" style="width:2%" prop="bindAmount" :show-overflow-tooltip="true" align="center" >
        <template slot-scope="scope">
          <span>{{ scope.row.bindAmount }}</span>
        </template>
      </el-table-column>
      <el-table-column label="会员赠送总金额（元）" style="width:2%" prop="vipAmount" :show-overflow-tooltip="true" align="center" >
        <template slot-scope="scope">
          <span>{{ scope.row.vipAmount }}</span>
        </template>
      </el-table-column>
      <el-table-column label="手动赠送总金额（元）" style="width:2%" prop="gameCoinsAmount" :show-overflow-tooltip="true" align="center" >
        <template slot-scope="scope">
          <span>{{ scope.row.gameCoinsAmount }}</span>
        </template>
      </el-table-column>
      <el-table-column label="游戏币赠送总金额（元）" style="width:2%" prop="giftCoinsAmount" :show-overflow-tooltip="true" align="center" >
        <template slot-scope="scope">
          <span>{{ scope.row.giftCoinsAmount }}</span>
        </template>
      </el-table-column>
      <el-table-column label="游戏币总消耗（元）" style="width:2%" prop="betAmount" :show-overflow-tooltip="true" align="center" >
        <template slot-scope="scope">
          <span>{{ scope.row.betAmount }}</span>
        </template>
      </el-table-column>
      <el-table-column label="消耗游戏币无存款用户数" style="width:2%" prop="betNoDepNum" :show-overflow-tooltip="true" align="center" >
        <template slot-scope="scope">
          <span>{{ scope.row.betNoDepNum }}</span>
        </template>
      </el-table-column>
      <el-table-column label="消耗游戏币后进行存款用户数" style="width:2%" prop="betDepNum" :show-overflow-tooltip="true" align="center" >
        <template slot-scope="scope">
          <span>{{ scope.row.betDepNum }}</span>
        </template>
      </el-table-column>
    </el-table>

    <!--分页-->
    <div class="block">
      <el-pagination
        @size-change="handleSizeChange"
        @current-change="handleCurrentChange"
        :current-page.sync="currentPage"
        :page-sizes="[40, 80, 120, 200]"
        :page-size="pageSize"
        layout="total, prev, pager, next, jumper, sizes"
        :total="total"
      ></el-pagination>
    </div>
  </div>
</template>

<script>
import {getActReportList,getSourceList} from "@/api/gameActReport";
import {
  export_json_to_excel
} from "@/vendor/Export2Excel";
    export default {
        components: {

        },
        created() {
            this.getGameManagerList();
            this.sourceList();

        },

        data() {
            return {
                sourceData: [
                  {
                    name:'全选',
                    source:''}
                ],
                tableData: [],
                sumTotals: [],
                totalList: [],
                queryParams:{
                  beginCreateTime: new Date(), //创建时间-开始
                  endCreateTime: new Date(),
                  source: "",
                },
                currentPage: 1,
                total: null,
                pageSize: 40,
                orderByDescColumn: "", // 降序字段
                orderByAscColumn: "", // 升序字段
            };
        },

        methods: {
          sourceList: function() {
            var sourceParams = {};
            sourceParams.pageSize = 1000;
            sourceParams.currentPage = 1;
            getSourceList(sourceParams).then(response => {
              this.sourceData.push(...response.data.records);
            });
          },
            getGameManagerList: function() {
                this.queryParams.currentPage = this.currentPage;
                this.queryParams.pageSize = this.pageSize;
                this.queryParams.orderByDescColumn = this.orderByDescColumn
                this.queryParams.orderByAscColumn = this.orderByAscColumn
              getActReportList(this.queryParams).then(response => {
                    this.tableData = response.data.records;
                    this.currentPage = response.data.current;
                    this.pageSize = response.data.size;
                    this.total = response.data.total;
                });
              this.queryParams.currentPage = 1;
              this.queryParams.pageSize = -1;
              this.queryParams.orderByDescColumn = this.orderByDescColumn
              this.queryParams.orderByAscColumn = this.orderByAscColumn
              getActReportList(this.queryParams).then(response => {
                this.sumTotals = response.data.records;
              });
            },


            changeSort (val) {
                // 根据当前排序重新获取后台数据,一般后台会需要一个排序的参数
                if(val.order == "ascending") {
                    this.orderByAscColumn = val.prop
                    this.orderByDescColumn = ""
                } else {
                    this.orderByAscColumn = ""
                    this.orderByDescColumn = val.prop
                }
                this.getGameManagerList();
            },

            handleFind: function() {
                this.currentPage = 1
                this.getGameManagerList();
            },
            /**
             * 翻页事件
             */
            handleSizeChange(val) {
                this.pageSize = val;
                this.getGameManagerList();
            },
            //改变页码
            handleCurrentChange(val) {
                this.currentPage = val;
                this.getGameManagerList();
            },
          // 导出excel数据
          exportData() {
            // 表头对应关系
            const headers = {
              '日期': 'period',
              '渠道': 'sourceName',
              '新人领取用户总数（人）': 'loginFirstNum',
              '绑定手机领取用户总数（人）': 'bindNum',
              '会员领取用户总数（人）': 'vipNum',
              '游戏币赠送用户总数（人）': 'giftCoinsNum',
              '新人赠送总金额（元）': 'loginFirstAmount',
              '绑定手机赠送总金额（元）': 'bindAmount',
              '会员赠送总金额（元': 'vipAmount',
              '手动赠送总金额（元）': 'gameCoinsAmount',
              '游戏币赠送总金额（元)': 'giftCoinsAmount',
              '游戏币总消耗（元）': 'betAmount',
              '消耗游戏币无存款用户数': 'betNoDepNum',
              '消耗游戏币后进行存款用户数': 'betDepNum',
            }
            this.queryParams.currentPage = 1;
            this.queryParams.pageSize = -1;
            this.queryParams.orderByDescColumn = this.orderByDescColumn
            this.queryParams.orderByAscColumn = this.orderByAscColumn
            getActReportList(this.queryParams).then(response => {
              const records = response.data.records;
              if(this.totalList.length>0){
                const totalInfo = new Map();
                totalInfo.set("period",this.totalList[0]);
                totalInfo.set("source",this.totalList[1]);
                totalInfo.set("loginFirstNum",this.totalList[2]);
                totalInfo.set("bindNum",this.totalList[3]);
                totalInfo.set("vipNum",this.totalList[4]);
                totalInfo.set("giftCoinsNum",this.totalList[5]);
                totalInfo.set("loginFirstAmount",this.totalList[6]);
                totalInfo.set("bindAmount",this.totalList[7]);
                totalInfo.set("vipAmount",this.totalList[8]);
                totalInfo.set("gameCoinsAmount",this.totalList[9]);
                totalInfo.set("giftCoinsAmount",this.totalList[10]);
                totalInfo.set("betAmount",this.totalList[11]);
                totalInfo.set("betNoDepNum",this.totalList[12]);
                totalInfo.set("betDepNum",this.totalList[13]);
                records.push(this.mapToObj(totalInfo));
              }
              const data = this.formatJson(headers, response.data.records)
              export_json_to_excel(Object.keys(headers), data, '活动概括报表')
            });
          },
          // 该方法负责将数组转化成二维数组
          formatJson(headers, rows) {
            // 首先遍历数组
            return rows.map(item => {
              return Object.keys(headers).map(key => {
                return item[headers[key]]
              })
            })
          },
          mapToObj(map){
            var obj = {};
            for(let [key,value] of map){
              obj[key] = value;
            }
            return obj;
          },
          getSummaries(param){
              param.data = this.sumTotals;
           this.totalList = [];
            const {columns,data} = param;
            const sums = [];
            columns.forEach((column,index)=> {
              if(index ===0){
                sums[index] = '总计';
                return;
              }
              if(index ===1){
                sums[index] = '';
                return;
              }
              const values = data.map(item => Number(item[column.property]));
              if(!values.every(value=> isNaN(value))){
                sums[index] = values.reduce((prev,curr)=>{
                  const value = Number(curr);
                  if(!isNaN(value)){
                    return prev +curr;
                  }else{
                    return prev;
                  }
                  sums[index] += '';
                },0)
              }else{
                sums[index] = 'N/A';
              }
            });
            this.totalList = sums;
            return sums;
          },
        }
    }
</script>

